/* AMXX Mod script.
*
* (c) Copyright 2008, developed by Lev
* This file is provided as is (no warranties). 
*/

#include <amxmodx>
#include <amxmisc>
#include <icqbot>

#define AUTHOR "Lev"
#define PLUGIN "Admin ICQ"
#define VERSION "1.1"

const BASE_TASK_ID = 4346	// random number

new g_adminicq_sendto;
new g_adminicq_trigger;
new g_adminicq_showinfo;
new g_adminicq_flood_time;

new Float:g_Flooding[33] = {0.0, ...}
new g_Flood[33] = {0, ...}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_cvar("adminicq_version", VERSION, FCVAR_SERVER);

	register_clcmd("say", "sayEvent");
	register_clcmd("say_team", "sayEvent");
	g_adminicq_sendto = register_cvar("adminicq_sendto","");
	g_adminicq_trigger = register_cvar("adminicq_trigger","!admin");
	g_adminicq_showinfo = register_cvar("adminicq_showinfo","1");
	g_adminicq_flood_time = register_cvar("adminicq_flood_time", "600");

	set_task(180.0, "showInfo", BASE_TASK_ID, "", 0, "b");
}

public sayEvent(id)
{
	new text[256];
	read_args(text, sizeof(text) - 1);
	remove_quotes(text);
	new adminicq_trigger[32];
	get_pcvar_string(g_adminicq_trigger, adminicq_trigger, sizeof(adminicq_trigger) - 1);
	if (containi(text, adminicq_trigger) != -1)
	{
		new Float:maxChat = get_pcvar_float(g_adminicq_flood_time);

		if (maxChat)
		{
			new Float:nexTime = get_gametime();

			if (g_Flooding[id] > nexTime)
			{
				if (g_Flood[id] >= 3)
				{
					client_print(id, print_notify, "** Stop flooding an admin! **");
					g_Flooding[id] = nexTime + maxChat + 3.0;
					return PLUGIN_HANDLED;
				}
				g_Flood[id]++;
			}
			else if (g_Flood[id])
			{
				g_Flood[id]--;
			}

			g_Flooding[id] = nexTime + maxChat;
		}

		new szName[32];
		new szAuthID[32];
		new szIP[32];
		get_user_name(id, szName, sizeof(szName) - 1);
		get_user_authid(id, szAuthID, sizeof(szAuthID) - 1);
		get_user_ip(id, szIP, sizeof(szIP) - 1);

		new ident[128];
		format(ident, sizeof(ident) - 1, " Name: %s; ID: %s, IP: %s", szName, szAuthID, szIP);
		add(text, sizeof(text) - 1, ident);

		new adminicq_sendto[256];
		get_pcvar_string(g_adminicq_sendto, adminicq_sendto, sizeof(adminicq_sendto) - 1);

		new admin[32];
		new admins[256];
		strtok(adminicq_sendto, admin, sizeof(admin) - 1, admins, sizeof(admins) - 1, ';', 1);
		while(!equal(admin, ""))
		{
			server_print(adminicq_sendto);
			server_print(text);
			send_icq_message(admin, text);
			strtok(admins, admin, sizeof(admin) - 1, admins, sizeof(admins) - 1, ';', 1);
		}
		client_print(id, print_chat, "Your message was sent to admin.");
	}

	return PLUGIN_CONTINUE;
}

public showInfo()
{
	if (get_pcvar_float(g_adminicq_showinfo) != 0)
	{
		new adminicq_trigger[32];
		get_pcvar_string(g_adminicq_trigger, adminicq_trigger, sizeof(adminicq_trigger) - 1);
		client_print(0, print_chat, "To contact a server admin on ICQ, type(say) ^"%s your text to admin^".", adminicq_trigger);
	}	
}
